unit Unit1;

// QMH 1.0  2/99 Jean Claude Meier
// Light soft to quickly manage (Read, Copy, Rename,Move,Delete, View source)
// files from the WEB (.HTML,.JPG,.GIF and other)
// Needs HTML.OCX correctly installed and registered
// Developped with Delphi V 2.01
// 17/9/99 added Print (D3, D4 ?) and saving of pathes
// Can be freely used at your risks and perils :-)))

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, ISP, StdCtrls, Menus, ShellAPI, ShlObj, Printers, Inifiles;

type
  TForm1 = class(TForm)
    HTML1: THTML;
    MainMenu1: TMainMenu;
    Load1: TMenuItem;
    Rename1: TMenuItem;
    Copy1: TMenuItem;
    Move1: TMenuItem;
    Delete1: TMenuItem;
    Source1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Print1: TMenuItem;
    procedure WndProc(var Msg: TMessage); override;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Source1Click(Sender: TObject);
    procedure HTML1DblClick(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure Rename1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Move1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure Lit_Ini;
    procedure Sauve_Ini;
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;


implementation

{$R *.DFM}

Var
  nom_fic : string;
  chemin_load,     (* way to load *)
  chemin_move,      (* way to move *)
  chemin_copy : string;  (* way to copy *)


function anti_slash2slash(chaine : string) : string;
var i : integer;
begin
  for i := 1 to length(chaine) do
  if chaine[i] = '\' then chaine[i] := '/';
  result := chaine;
end;

// Load file
procedure charge_fic(le_fic : string);
var disque, rep : string;
begin
  form1.caption := le_fic;
  disque := copy(le_fic,1,1);
  rep := copy(le_fic,3,length(nom_fic)-2);
  form1.HTML1.RequestDoc('file:///'+disque+'|'+ anti_slash2slash(rep));
end;

procedure TForm1.WndProc(var Msg: TMessage);
var
  buff : string;
begin
  SetLength(buff,Max_Path);
  if (Msg.Msg = WM_DropFiles) then
  begin
    Msg.Result := 0;
    DragQueryFile(Msg.wParam, 0, Pchar(buff), Max_Path);
    nom_fic := buff;
    caption := nom_fic;
    try
      charge_fic(nom_fic);
    finally
     SetForegroundWindow(Application.handle);
    end;
      DragFinish(Msg.wParam);
   end
   else
     inherited WndProc(Msg);
end;

// To load file on command line
procedure TForm1.FormCreate(Sender: TObject);
begin
  Lit_Ini;
  nom_fic := '';
  DragAcceptFiles(Handle, True);
  if ParamCount > 0 then
  begin
    nom_fic := ParamStr(1);
    Charge_Fic(nom_fic);
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Sauve_Ini;
  DragAcceptFiles(Handle, false);
end;

// Show source
procedure TForm1.Source1Click(Sender: TObject);
begin
  if HTML1.ViewSource = false
  then HTML1.ViewSource := true
  else HTML1.ViewSource := false;
end;

procedure TForm1.HTML1DblClick(Sender: TObject);
begin
  Close; (* I like to close by clicking everywhere but do what you want! *)
end;

// Delete file
procedure TForm1.Delete1Click(Sender: TObject);
var
  F : TShFileOpStruct;
begin
  If ((ExtractFileName(nom_fic) = '') or
  (ExtractFileName(nom_fic) = 'p_vide.htm'))
  then exit;
  FillChar(F, SizeOf(F), #0);
  F.Wnd := Handle;
  F.wFunc := FO_DELETE;
  F.pFrom := Pchar(nom_fic+#0#0);
  F.fFlags := FOF_ALLOWUNDO OR FOF_NOCONFIRMATION;
  if ShFileOperation(F) <> 0 then
  begin
    ShowMessage('Delete Failed');
    exit;
  end;
  Close; // I prefer to close here
  (*
  nom_fic := ExtractFilePath(Application.ExeName)+'p_vide.htm';
  charge_fic(nom_fic);
  *)
end;
// Load file on request
procedure TForm1.Load1Click(Sender: TObject);
begin
  OpenDialog1.InitialDir := chemin_load;
  If OpenDialog1.execute then
  begin
    nom_fic := Opendialog1.FileName;
    Charge_Fic(nom_fic);
    chemin_load := ExtractFilePath(nom_fic);
  end;
end;
// Rename file
procedure TForm1.Rename1Click(Sender: TObject);
Var clickOk : boolean;
    chaine : string;
begin
  If ((ExtractFileName(nom_fic) <> '') or
  (ExtractFileName(nom_fic) <> 'p_vide.htm')) then
  begin
     chaine := '';
     ClickOK := InputQuery('New name of '+ExtractFileName(nom_fic),
     'Vrify (name[.ext]) and confirm', chaine);
     If Pos('.',Chaine) = 0 then chaine := chaine+ExtractFileExt(nom_fic);
     if ClickOK then
     begin
       if not renamefile(nom_fic,ExtractFilePath(nom_fic)+chaine)
       then MessageDlg('Impossible to rename this file',
       mtError,[mbok],0)
       else
       begin
         nom_fic := ExtractFilePath(nom_fic)+chaine;
         caption := nom_fic;
       end;
     end;
  end;
end;

// Copy file
procedure TForm1.Copy1Click(Sender: TObject);
var
  F : TShFileOpStruct;
begin
  If ((ExtractFileName(nom_fic) = '') or
  (ExtractFileName(nom_fic) = 'p_vide.htm'))
  then exit;
  SaveDialog1.Title := 'Copy';
  SaveDialog1.FileName := chemin_copy+ExtractFileName(nom_fic);
  If saveDialog1.Execute then
  begin
    FillChar(F, SizeOf(F), #0);
    F.Wnd := Handle;
    F.wFunc := FO_COPY;
    F.pFrom := Pchar(nom_fic+#0#0);   // full name + #0#0 !
    F.pTo := PChar(SaveDialog1.FileName);
    F.fFlags := FOF_ALLOWUNDO or FOF_RENAMEONCOLLISION;
    if ShFileOperation(F) <> 0 then  ShowMessage('Copy Failed');
    chemin_copy := ExtractFilePath(SaveDialog1.FileName);
  end;
end;

// Move file
procedure TForm1.Move1Click(Sender: TObject);
var
  F : TShFileOpStruct;
begin
 If ((ExtractFileName(nom_fic) = '') or
  (ExtractFileName(nom_fic) = 'p_vide.htm'))
  then exit;
  SaveDialog1.Title := 'Move';
  SaveDialog1.FileName := chemin_move+ExtractFileName(nom_fic);
  If saveDialog1.Execute then
  begin
    FillChar(F, SizeOf(F), #0);
    F.Wnd := Handle;
    F.wFunc := FO_MOVE;
    F.pFrom := Pchar(nom_fic+#0#0);
    F.pTo := PChar(SaveDialog1.FileName);
    F.fFlags := FOF_ALLOWUNDO or FOF_RENAMEONCOLLISION;
    if ShFileOperation(F) <> 0 then  ShowMessage('Move Failed')
    else
    (*
    begin
      nom_fic := ExtractFilePath(Application.ExeName)+'p_vide.htm';
      charge_fic(nom_fic);
    end;
    *)
    Close; // alternately I prefer to close here, but ...
    chemin_move := ExtractFilePath(SaveDialog1.FileName);
  end;
end;
(* Print file *)
procedure TForm1.Print1Click(Sender: TObject);
var
   OldCur: TCursor;
 begin
   If ((ExtractFileName(nom_fic) = '') or
   (ExtractFileName(nom_fic) = 'p_vide.htm'))
   then exit;
   {$ifndef ver90}
   OldCur := Screen.Cursor;
   with Printer do begin
     BeginDoc;
     HTML1.AutoPrint(handle);
     Title := HTML1.URL;
     EndDoc;
   end;
   Screen.Cursor := OldCur;
   {$else}
   showmessage('Doesn''t work in D2');
   {$endif}
 end;

(* Reading of the pathes *)
procedure TForm1.Lit_Ini;
VAR ProgIni : TIniFile;
begin
  ProgIni := TInifile.Create(ChangeFileExt(ParamStr(0),'.INI'));
  Chemin_load := ProgIni.ReadString('Configuration','Chemin de chargement',
  ExtractFilePath(ParamStr(0)));
  Chemin_copy := ProgIni.ReadString('Configuration','Chemin de copie',
  ExtractFilePath(ParamStr(0)));
  Chemin_move := ProgIni.ReadString('Configuration','Chemin de dplacement',
  ExtractFilePath(ParamStr(0)));
  ProgIni.Free;
end;
(* Saving of the pathes *)
procedure TForm1.Sauve_Ini;
VAR ProgIni : TIniFile;
begin
  ProgIni := TInifile.Create(ChangeFileExt(ParamStr(0),'.INI'));
  ProgIni.WriteString('Configuration','Chemin de chargement',
  Chemin_load);
  ProgIni.WriteString('Configuration','Chemin de copie',
  Chemin_copy);
  ProgIni.WriteString('Configuration','Chemin de dplacement',
  Chemin_move);
  ProgIni.Free;
end;

end.


